/////////////////////////////////////////////////////////////////
//
// pbopack.cpp
// Version 1.0
// (c)2003 by Ales Mlakar aka JaZzBrE (jazzbre@xubl.com)
//
//
/////////////////////////////////////////////////////////////////

#include "pbo.h"

/////////////////////////////////////////////////////////////////
//
// Total Commander exported functions
//
/////////////////////////////////////////////////////////////////

HANDLE __stdcall OpenArchive (tOpenArchiveData *ArchiveData)
{
   PboPack  *pbo = new( PboPack );

   if (!pbo->Open(ArchiveData->ArcName))
   {
      delete( pbo );
      return 0;
   }

   return pbo;
}

int __stdcall ReadHeader (HANDLE hArcData, tHeaderData *HeaderData)
{
   PboPack  *pbo = (PboPack*) hArcData;

   PboEntry *ent = pbo->Entry[pbo->curfile];
   
   strcpy( HeaderData->ArcName, pbo->CurName.c_str() );
   strcpy( HeaderData->FileName, ent->filename.c_str() );

   HeaderData->FileAttr=0x20;
   HeaderData->PackSize = HeaderData->UnpSize = ent->size;
   pbo->curfile++;
   
   if (pbo->curfile>=pbo->Entry.size())
   {      
      return E_END_ARCHIVE;
   }

   return 0;
}


int __stdcall CloseArchive (HANDLE hArcData)
{
   PboPack  *pbo = (PboPack*) hArcData;
   pbo->Close();
   delete( pbo );
   return 1;
}

int __stdcall ProcessFile (HANDLE hArcData, int Operation, char *DestPath, char *DestName)
{   
   PboPack  *pbo = (PboPack*) hArcData;

   if (pbo->curprocessfile>=pbo->Entry.size())
   {
      pbo->curprocessfile=0;
   }

   if (Operation==PK_EXTRACT)
   {      
      /*
      char str[256];
      sprintf(str, "%s %d, %s %s %d", pbo->Entry[pbo->curprocessfile]->filename.c_str(), Operation, DestPath, DestName, pbo->Entry[pbo->curprocessfile]->unknown[0] );
      MessageBox(0, "test", str, MB_OK );*/ 
      pbo->ExtractFile(pbo->Entry[pbo->curprocessfile], DestName );
   }
   
   pbo->curprocessfile++;  
   
   return 0;
}

void __stdcall SetChangeVolProc (HANDLE hArcData, tChangeVolProc pChangeVolProc1)
{
}

static tProcessDataProc __pProcessDataProc;

void __stdcall SetProcessDataProc (HANDLE hArcData, tProcessDataProc pProcessDataProc)
{
   __pProcessDataProc=pProcessDataProc;
   if (hArcData && hArcData!=(HANDLE)0xFFFFFFFF)
   {
      PboPack  *pbo = (PboPack*) hArcData;
      pbo->m_ProcessDataProc=pProcessDataProc;
   }
}

int __stdcall GetPackerCaps()
{  
   return PK_CAPS_NEW | PK_CAPS_MULTIPLE | PK_CAPS_OPTIONS;
}

int __stdcall PackFiles (char *PackedFile, char *SubPath, char *SrcPath, char *AddList, int Flags)
{   
   char str[256];
   if (!SubPath)
      SubPath="";

   vector<string> fnames;

   int  n=0;
   for (int i=0;i<0xFFFFFFFF;i++)
   {
      if (AddList[i]==0)
      {                  
         str[n]=0;
         fnames.push_back( string(str) );
         n=0;
         if (AddList[i+1]==0)
            break;
      }
      else
      {
         str[n++] = AddList[i];
      }
   }
 
   PboPack *pbo=new PboPack;
   pbo->m_ProcessDataProc=__pProcessDataProc;
   pbo->CompressFiles(fnames, SrcPath, PackedFile);
   delete pbo;

   return 0;
}

int __stdcall DeleteFiles (char *PackedFile, char *DeleteList)
{
   return 0;
}

void __stdcall ConfigurePacker (HWND Parent, HINSTANCE DllInstance)
{ 
}

